diff --git a/docs/deployment/management.rst b/docs/deployment/management.rst
index 9c57f19..3a9bb2b 100644
--- a/docs/deployment/management.rst
+++ b/docs/deployment/management.rst
@@ -116,6 +116,32 @@ the :ref:`deployment installation guide <deployment-parsemail>`.
 
    input mbox filename. If not supplied, a patch will be read from ``stdin``.
 
+parserelations
+~~~~~~~~~~~~~~
+
+.. program:: manage.py parserelations
+
+Parse a patch groups file and store any relation found
+
+.. code-block:: shell
+
+    ./manage.py parserelations <infile>
+
+This is a script used to ingest relations into Patchwork.
+A patch groups file contains on each line patchwork ids of patches that form a relation.
+Eg contents of a patch groups file:
+
+    1 3 5
+    2
+    7 10 11 12
+
+In this case the script will identify 2 relations, (1, 3, 5) and (7, 10, 11, 12).
+Running this script will remove all existing relations and replace them with the relations found in the file.
+
+.. option:: infile
+
+    input patch groups file.
+
 rehash
 ~~~~~~
 
diff --git a/patchwork/management/commands/parserelations.py b/patchwork/management/commands/parserelations.py
new file mode 100644
index 0000000..ca8a523
--- /dev/null
+++ b/patchwork/management/commands/parserelations.py
@@ -0,0 +1,71 @@
+# Patchwork - automated patch tracking system
+# Copyright (C) 2020 Rohit Sarkar <rohitsarkar5398@gmail.com>
+#
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+import logging
+import os
+import sys
+
+from django.db import transaction
+from django.core.management.base import BaseCommand
+
+from patchwork.models import Patch
+from patchwork.models import PatchRelation
+
+logger = logging.getLogger(__name__)
+
+class Command(BaseCommand):
+    help = 'Parse a relations file generated by PaStA and replace existing relations with the ones parsed'
+
+    def add_arguments(self, parser):
+        parser.add_argument(
+            'infile',
+            help='input relations filename')
+    
+    def handle(self, *args, **options):   
+        verbosity = int(options['verbosity'])
+        if not verbosity:
+            level = logging.CRITICAL
+        elif verbosity == 1:
+            level = logging.ERROR
+        elif verbosity == 2:
+            level = logging.INFO
+        else:
+            level = logging.DEBUG
+
+        logger.setLevel(level)
+
+        path = args and args[0] or options['infile']
+        if not os.path.exists(path):
+            logger.error('Invalid path: %s', path)
+            sys.exit(1)
+        
+
+        with open(path, 'r') as f:
+            lines = f.readlines()
+        
+        # filter out trailing empty lines
+        while len(lines) and not lines[-1]:
+            lines.pop()
+
+        relations = [line.split(' ') for line in lines]
+
+        with transaction.atomic():
+            PatchRelation.objects.all().delete()
+            count = len(relations)
+            ingested = 0
+            logger.info('Parsing %d relations' % count)
+            for i, patch_ids in enumerate(relations):
+                related_patches = Patch.objects.filter(id__in=patch_ids)                               
+                if len(related_patches) > 1:
+                    relation = PatchRelation()
+                    relation.save()
+                    related_patches.update(related=relation)
+                    ingested += 1
+                
+                if i % 10 == 0:
+                    self.stdout.write('%06d/%06d\r' % (i, count), ending='')
+                    self.stdout.flush()
+            
+            self.stdout.write('Ingested %d relations' % ingested)
diff --git a/patchwork/tests/test_management.py b/patchwork/tests/test_management.py
index 66c6bad..186ea56 100644
--- a/patchwork/tests/test_management.py
+++ b/patchwork/tests/test_management.py
@@ -124,3 +124,10 @@ class ParsearchiveTest(TestCase):
 
         self.assertIn('Processed 1 messages -->', out.getvalue())
         self.assertIn('  1 dropped', out.getvalue())
+
+class ParserelationsTest(TestCase):
+    def test_invalid_path(self):
+        out = StringIO()
+        with self.assertRaises(SystemExit) as exc:
+            call_command('parserelations', 'xyz123random', stdout=out)
+        self.assertEqual(exc.exception.code, 1)